// Objective-C API for talking to github.com/nknorg/eth-resolver-go Go package.
//   gobind -lang=objc github.com/nknorg/eth-resolver-go
//
// File is generated by gobind. Do not edit.

#ifndef __Ethresolver_H__
#define __Ethresolver_H__

@import Foundation;
#include "ref.h"
#include "Universe.objc.h"

#include "Nkngomobile.objc.h"

@class EthresolverConfig;
@class EthresolverResolver;

/**
 * Config is the Resolver configuration.
 */
@interface EthresolverConfig : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) _Nonnull id _ref;

- (nonnull instancetype)initWithRef:(_Nonnull id)ref;
- (nonnull instancetype)init;
@property (nonatomic) NSString* _Nonnull prefix;
@property (nonatomic) NSString* _Nonnull rpcServer;
@property (nonatomic) NSString* _Nonnull contractAddress;
// skipped field Config.CacheTimeout with unsupported type: time.Duration

@property (nonatomic) long dialTimeout;
@end

/**
 * Resolver implement ETH resolver.
 */
@interface EthresolverResolver : NSObject <goSeqRefInterface, NkngomobileResolver> {
}
@property(strong, readonly) _Nonnull id _ref;

- (nonnull instancetype)initWithRef:(_Nonnull id)ref;
/**
 * NewResolver creates a Resolver. If config is nil, the default Resolver config will be used.
 */
- (nullable instancetype)init:(EthresolverConfig* _Nullable)config;
/**
 * Resolve wraps ResolveContext with background context.
 */
- (NSString* _Nonnull)resolve:(NSString* _Nullable)address error:(NSError* _Nullable* _Nullable)error;
// skipped method Resolver.ResolveContext with unsupported parameter or return types

@end

/**
 * DefaultDialTimeout Dial timeout
 */
FOUNDATION_EXPORT const int64_t EthresolverDefaultDialTimeout;

@interface Ethresolver : NSObject
// skipped variable DefaultEthereumConfig with unsupported type: github.com/nknorg/eth-resolver-go.Config

// skipped variable DefaultHarmonyConfig with unsupported type: github.com/nknorg/eth-resolver-go.Config

// skipped variable DefaultIotexConfig with unsupported type: github.com/nknorg/eth-resolver-go.Config

// skipped variable DefaultThetaConfig with unsupported type: github.com/nknorg/eth-resolver-go.Config

@end

FOUNDATION_EXPORT EthresolverConfig* _Nullable EthresolverGetDefaultEthereumConfig(void);

FOUNDATION_EXPORT EthresolverConfig* _Nullable EthresolverGetDefaultHarmonyConfig(void);

FOUNDATION_EXPORT EthresolverConfig* _Nullable EthresolverGetDefaultIotexConfig(void);

FOUNDATION_EXPORT EthresolverConfig* _Nullable EthresolverGetDefaultThetaConfig(void);

/**
 * MergeConfig merges a given Resolver config with the default Resolver config
recursively. Any non zero value fields will override the default config.
 */
FOUNDATION_EXPORT EthresolverConfig* _Nullable EthresolverMergeConfig(EthresolverConfig* _Nullable config, NSError* _Nullable* _Nullable error);

/**
 * NewDefaultResolvers creates default Resolvers.
 */
FOUNDATION_EXPORT NkngomobileResolverArray* _Nullable EthresolverNewDefaultResolvers(NSError* _Nullable* _Nullable error);

/**
 * NewResolver creates a Resolver. If config is nil, the default Resolver config will be used.
 */
FOUNDATION_EXPORT EthresolverResolver* _Nullable EthresolverNewResolver(EthresolverConfig* _Nullable config, NSError* _Nullable* _Nullable error);

#endif
